/************************ AGNIESZKA NOWAKOWSKA G1ISIII ************************/
//
/**** biblioteka stl, opis algorytmw : next_permutation prev_permutation *****/
//
//Algorytmy zdefiniowane s STL (standardowej bibliotece szablonw).
//Wykonuj permutacj na cigach elementw.
//Istnieje zawsze skoczona liczba permutacji (cig skoczony).
//Dla permutacji bez powtrze jest to n!, gdzie n-dugoc cigu.
//Dla permutacji z powtrzeniami n!/(n1!*n2! ... * nk!), gdzie n-dugoc cigu, ni-liczba powtrze danego elementu
//
/************************************ prev_permutation *************************************/
//
//		template <class BidirectionalIterator>
//		bool prev_permutation(BidirectionalIterator first, BidirectionalIterator last);
//
//		template <class BidirectionalIterator, class StrictWeakOrdering>
//		bool prev_permutation(BidirectionalIterator first, BidirectionalIterator last, StrictWeakOrdering comp);
//
//prev_permutation tworzy poprzedni "mniejsz" permutacj danego cigu w porzdku leksykograficznym, 
//przyjmuje jako argumenty:
//*iteratory do pierwszego i ostatniego elementu permutowanego cigu (szablon pierwszy)
//*iteratory do pierwszego i ostatniego elementu permutowanego cigu oraz funkcje uytkownika suaca do 
//porwnywania permutowanych elementw(szablon drugi)
//zwraca true i transformuje cig, kiedy istnieje porzednia permutacja
//zwraca false i transformuje w leksykograficznie najwikszy cig, gdy poprzednia permutacja nie istnieje
//najwikszy leksykograficznie cig bdzie uporzdkowany nierosnco
//
/************************************ next_permutation *************************************/
//
//		template <class BidirectionalIterator>
//		bool next_permutation(BidirectionalIterator first,BidirectionalIterator last);
//
//		template <class BidirectionalIterator, class StrictWeakOrdering>
//		bool next_permutation(BidirectionalIterator first, BidirectionalIterator last,StrictWeakOrdering comp);
//
//next_permutation tworzy nastepn "wiksza" permutacj danego cigu w porzdku leksykograficznym, 
//przyjmuje jako argumenty:
//*iteratory do pierwszego i ostatniego elementu permutowanego cigu (szablon pierwszy)
//*iteratory do pierwszego i ostatniego elementu permutowanego cigu oraz funkcje uytkownika suaca do 
//porwnywania permutowanych elementw(szablon drugi)
//zwraca true i transformuje cig, kiedy istnieje nastpna permutacja
//zwraca false i transformuje w leksykograficznie najmniejszy cig, gdy poprzednia permutacja nie istnieje
//najwikszy leksykograficznie cig bdzie uporzdkowany niemalejco

/*****Poniej prezentacja dwch sposobw uycia opisanych funkcji*****/

#include <algorithm>	//nagwek biblioteki zawierajacej omawiane algorytmy
#include <iostream>
#include <vector>
#include <string>
#include <ctime>

const int ASCEND = 0;	//rosncy porzdek cigu
const int DESCEND = 1;	//malejcy porzdek cigu

using namespace std;

typedef vector<char> CharVector;
typedef vector<int> IntVector;

//szablon do wypisania danych zawartych w wektorze
template<class type>
ostream& write (ostream& cons, type& vect)
{
	for(unsigned i = 0; i< vect.size(); ++i)
	{
		cons<< vect[i] << " ";
	}
	cons<< std::endl;
	return cons;
}

//wykorzystanie algorytmw next_permutation i prev_permutation do generacji wszystkich permutacji danego acucha znakw 
//funkcja przyjmuje 1 argument typu string, wypisuje wszystkie permutacje znakw tworzcych dane sowo/ dany cig i zwraca ich liczb
int AllPermutations (string& word) 
{
	CharVector Elements;					//wektor, do ktrego zapisany zostanie ciag znakw
	int counter = 0;						//licznik permutacji
	
	for (unsigned i=0; i<word.size(); ++i)	//wypenienie wektora
	{
		Elements.push_back(word[i]);
	}

	CharVector Store = Elements;					//wykonanie kopii cigu poczatkowego
	prev_permutation(Store.begin(), Store.end());	//pierwsza permutacja i zwikszenie licznika
	++counter;										//dalsze permutacje w ptli zaczniemy od nastpnej permutacji,
	write(cout, Elements);							//aby umozliwi proste sprawdzenie warunku koca ptli 
	
	while (Elements!=Store)									//ptla, w ktrej wykonujemy i wypisujemy kolejne permutacje 			
	{														//warunkiem zakoczenia jest "powrt" do pierwszego cigu,
		next_permutation(Elements.begin(), Elements.end()); //cig znakw, bdzie rwny wejciowemu cigowi,
		++counter;											//co oznacza, e wypisane zostay wszystkie permutacje
		write(cout, Elements);
	} 
	return counter;
}

//wykorzystanie algorytmw next_permutation i prev_permutation do sortowania
//funkcja sortuje nieuporzadkowany cig liczb w wektorze, przyjmuje 2 argumenty: referencje do wektora z danymi oraz zmienn typu int
//informujc o porzdku sortowania, w celu uproszczenia zdefiniowano stae ASCENT - porzdek rosncy, DESCENT - porzdek malejacy 
//zwraca liczbe permutacji wykonanych do posortowania elemetw
//funkcja nie sprawdza czy podany cig nie jest uporzdkowany 
//(w przypadku posortowanego w odpowiedniej kolejnoci wykonuje niepotrzebne obliczenia, w celach demonstracyjnych)
//sortowanie duej iloci elementw jest mao wydajne

int PermSort(IntVector& vect, int order)
{
	bool result = true;
	int counter = 0;				//licznik permutacji
	if(order == ASCEND)				//jeli sortujemy rosnco
	{								//obliczamy nastpne permutacje, co zapewnia porzdek rosncy 
		while (result == true)		//a do zwrcenia przez funkcj wartoci false
		{							//co jest rwnoznaczne, z otrzymaniem ostatniej permutacji,
			result = next_permutation(vect.begin(), vect.end()); //a wic ciagu uporzadkowanego rosnco
			++counter;
		}
	}
	else							//jeli sortujemy malejco
	{								//w analogicznie skonstruowanej ptli 
		while (result == true)		//obliczamy poprzednie permutacje
		{							//wiec w momencie zwrcenia przez prev_permutation false bdziemy mieli cig posortowany malejaco
			result = prev_permutation(vect.begin(), vect.end());
			++counter;
		}
	}
	return counter;
}

int main()
{
	//demonstracja- wypisanie wszystkich permutacji cigu znakw
	cout << "/**************DEMO1************/" << endl;
	cout << "\nOBLICZANIE WSZYSTKICH PERMUTACJI ZNAKOW TWORZACYCH WYRAZ." << endl;
	string word;
	cout << "\nPodaj wyraz: ";
	cin >> word;
	getchar();

	int result = AllPermutations(word);
	cout << "Liczba permutacji wyrazu " << word.c_str() << " wynosi " << result << endl;
	cout << "\nPress a key to conitinue" << endl ;
	getchar();

	//demonstracja - sortowanie cigu liczb
	cout << "/**************DEMO2************/" << endl;
	cout << "\nSORTOWANIE CIAGU LICZB." << endl;
	IntVector SortVectAs, SortVectDes;

	int length = 0;
	int range = 0;

	cout << "\nPodaj dlugosc ciagu: ";
	cin >> length;
	getchar();

	cout << "\nPodaj maksymalna wartosc: ";
	cin >> range;
	getchar();
	
	//losowa generacja cigu do sortowania
	srand(static_cast<unsigned>(time(0))) ;
	for(int i=0; i<length; ++i)
	{
		int number = rand()%(range+1);
		SortVectAs.push_back(number);
		SortVectDes.push_back(number);
	}

	cout << "Wektor liczby losowych: ";
	write(cout, SortVectAs);

	result = PermSort(SortVectAs, ASCEND);
	cout << "Wektor posortowany rosnaco: ";
	write(cout, SortVectAs);
	cout << "Liczba wykonanych permutacji: " << result << endl;

	result = PermSort(SortVectDes, DESCEND);
	cout << "Wektor posortowany malejaco: ";
	write(cout, SortVectDes);
	cout << "Liczba wykonanych permutacji: " << result << endl;
	
	cout<<"Press a key to exit." << endl;
	getchar();	
}